
*------------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*------------------------------------------*

#include "hmg.ch"
#include "adordd.ch"     
#include "adordd.prg"
*--------------------------------------------*

 REQUEST SDDODBC, SQLMIX ,  ADORDD
 #define RDDI_CONNECT          1001
 PROC main()

                         
       RDDSETDEFAULT( "SQLMIX" )        
       SET( 4, "yyyy-mm-dd" )
       RDDINFO( RDDI_CONNECT, { "ODBC", "DBQ="  + "test.mdb;Driver={Microsoft Access Driver (*.mdb)}" } )
       DBUSEAREA( .T.,, "select * from test", "test" )
       dbgotop()

  SET CODEPAGE TO UNICODE  
  
  SET EXCLUSIVE OFF
  SET CENTURY ON 
  SET DATE FRENCH 
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET EPOCH TO 2000
  SET ESCAPE ON
  SET DELETED ON 
  SET NAVIGATION EXTENDED
  SET BROWSESYNC ON
  SET DECIMALS TO 0

  DEFINE WINDOW Form_1     ;
      AT 90,90             ;
      WIDTH 580            ;
      HEIGHT 330           ;
      TITLE "Adordd  Grid - " + STR( YEAR( DATE()) ) ;
      MAIN NOSIZE NOMAXIMIZE                 
      ON KEY ESCAPE ACTION Form_1.Release  

    Private bColor := { || IIF( This.CellRowIndex / 2 == INT( This.CellRowIndex / 2 ), { 255, 202, 149 } , { 080, 240, 006 } ) } //<--- Color Columna
    Private fColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , BLUE , YELLOW ) } // <---- letras  

*-------------------------------------------------------------*
  _HMG_SYSDATA [ 348 ] := { 199,250,225 }    
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }   
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }   
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }  
*-------------------------------------------------------------*
 
            
      aTable := { 'test->Code' , 'test->Name' , 'test->Phone' , 'test->Date', 'test->Married', 'test->Notes' , 'test->Photo'}  
       
                 DEFINE GRID Grid_1
                        ROW    020
                        COL    020
                        WIDTH  535  
                        HEIGHT 185  
			WIDTHS  { 085, 254 , 098 , 115 , 075 , 0 , 0}                   // 0 <------------------- porque asi no sale en Grid
                        HEADERS {"Code", "Name", "Phone", "Date", "Married", "", ""}    //"Notes" "" <----------- because that's not in Grid
			ROWSOURCE "TEST"
                        COLUMNFIELDS aTable
                        JUSTIFY { GRID_JTFY_RIGHT , GRID_JTFY_LEFT , GRID_JTFY_LEFT , GRID_JTFY_LEFT , GRID_JTFY_LEFT , GRID_JTFY_LEFT , GRID_JTFY_LEFT } 
                        FONTNAME 'Arial'
                        FONTSIZE 9
                        FONTBOLD .T.
                        FONTITALIC .F.
                        SHOWHEADERS .T. 
                        ONCHANGE PositionData()  
                        CELLNAVIGATION .F. 
                        DYNAMICFORECOLOR { fcolor, fcolor, fcolor, fcolor, fcolor, fcolor, fcolor} 
                        DYNAMICBACKCOLOR { bColor ,bColor ,bColor ,bColor ,bColor ,bColor ,bColor }
  	         END GRID

*--------------------------------------- Up-Down ------------------------------------------------*           

    DEFINE BUTTON But_01  
         ROW    240    
         COL    195          
         WIDTH  030
         HEIGHT 030 
         PICTURE "resource/Imagen01.jpg"              
         TOOLTIP 'First' 
         ACTION ( dBGoTop() ,  Form_1.Grid_1.RecNo := TEST->(RecNo()) , PositionData() )                      
     END BUTTON   
     
     DEFINE BUTTON But_02 
         ROW    240  
         COL    225  
         WIDTH  030
         HEIGHT 030 
         PICTURE "resource/Imagen02.jpg"             
         TOOLTIP 'Previous'
         ACTION  ( dBSkip ( -1 ) ,  Form_1.Grid_1.RecNo := TEST->(RecNo()) , PositionData() ) 
    END BUTTON
 
    DEFINE BUTTON But_03
         ROW    240 
         COL    255  
         WIDTH  030
         HEIGHT 030 
         PICTURE "resource/Imagen03.jpg"         
         TOOLTIP 'Next'
         ACTION ( dBSkip (1) , if ( Eof() , DbGoBottom() , Nil ) ,  Form_1.Grid_1.RecNo := TEST->(RecNo()) , PositionData() )            
    END BUTTON   
    
    DEFINE BUTTON But_04
         ROW    240 
         COL    285  
         WIDTH  030
         HEIGHT 030 
         PICTURE "resource/Imagen04.jpg"              
         TOOLTIP 'Last'  
         ACTION ( dBGoBottom () ,  Form_1.Grid_1.RecNo :=  TEST->(RecNo())  , PositionData()  )
    END BUTTON   
 
*-------------------------------------------------------------------------*

              @ 244, 040 Label Label_1G    ;
                     width   120           ;
                     height  035           ;
                     FONT "Arial" SIZE 9 BOLD ITALIC;
                     Value "Records:"
                   
              @ 244, 110 Label Label_2G    ;
                     width   050           ;
                     height  035           ;
                     FONT "Arial" SIZE 9 BOLD ITALIC;
                     Value ""
*-------------------------------------------------------------------------*

   DEFINE BUTTON But_Exit
         ROW    240
         COL    430 
         WIDTH  105
         HEIGHT 030
         CAPTION "&Exit" 
         PICTURE "Resource\Cancel.bmp"
         PICTALIGNMENT LEFT           
         ACTION Form_1.Release
    END BUTTON  
 
    Chane_Style()

   END WINDOW

   SETWINDOWCURSOR ( Form_1.But_Exit.Handle , "resource\finger.cur")

    Form_1.Grid_1.Refresh
    Form_1.Grid_1.SetFocus  

   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

Return nil

*------------------------------------------------------------* 
FUNCTION Chane_Style()   // Hace Recuadro en Grid
*------------------------------------------------------------* 
 HMG_ChangeWindowStyle ( GetControlHandle("Grid_1","Form_1"), LVS_REPORT, NIL, .T. )

Return

*------------------------------------------------------------* 
 FUNCTION PositionData()  // N de Registro / Total  
*------------------------------------------------------------*
 aReg    :=  Form_1.Grid_1.Value  
 nValor  :=  0
 Regs    :=  STR( Form_1.Grid_1.ItemCount )  
 
   Select('test')
   nValor := aReg[1] 
   Form_1.Label_2G.value := ALLTRIM( STR( nValor ) ) + SPACE(1) + "/" + SPACE(1) + ALLTRIM( Regs)  

Return 


*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*