/*
SALINETAS24 & KDJ
muy agradecido por vuestra colaboracin
very grateful for your collaboration 
*/

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*
    
#include <hmg.ch>

Function Main

   REQUEST DBFCDX , DBFFPT , DBFDBT
   RDDSETDEFAULT( "DBFCDX" )

   REQUEST HB_CODEPAGE_ESWIN     
   HB_SETCODEPAGE("ESWIN")    
 
   REQUEST HB_LANG_ES   
   HB_LANGSELECT("ES")  
*----------------------------------* 
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH  
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET DECIMALS TO 2
  SET INTERACTIVECLOSE OFF
*----------------------------------------------------------------------------------------------------------------------*
   fColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , BLUE , RED ) }
   bcolor := { || if ( This.CellRowIndex/2 = int (This.CellRowIndex/2) , {180,200,255} , {255,255,211} ) }
*-------------------------------------------------------- Color Barra Video Inversa ------------------------------------*
  _HMG_SYSDATA [ 348 ] := { 199,250,225 }
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }
*----------------------------------------------------------------------------------------------------------------------*

 PUBLIC aRows   := {} 
 
 CreateArray_1()

        DEFINE WINDOW Form_1               ;
                  AT 0,0                   ;
                  WIDTH  700               ;  
                  HEIGHT 560               ; 
	          TITLE 'DBF -->  Grid Virtual (Arrays)' ;   
		  MAIN NOMAXIMIZE NOSIZE   ;
                  ON INIT IniTius()   

                  ON KEY ESCAPE ACTION  Form_1.Release 

       @ 050,180 LABEL Label_0 ;
		 WIDTH 500 HEIGHT 24 ;
		 VALUE 'DBF -->  Grid Virtual (Arrays)' ;
		 FONT 'Arial' SIZE 17  BOLD ITALIC
 
    DEFINE GRID Grid_2      // <--- Productos
      ROW     100
      COL     100
      WIDTH   500 
      HEIGHT  260 
      HEADERS { "Ref","Producto","Tipo","Precio","CBarras","Vector" }
      WIDTHS  { 068 , 155 , 080 , 065 , 110, 0 }  
      JUSTIFY { GRID_JTFY_RIGHT, GRID_JTFY_LEFT, GRID_JTFY_LEFT , GRID_JTFY_RIGHT, GRID_JTFY_LEFT , GRID_JTFY_RIGHT }
      ITEMS aRows
      DYNAMICFORECOLOR { fColor , fColor, fColor , fColor, fColor, fColor  } 
      DYNAMICBACKCOLOR { bColor , bColor, bColor , bColor, bColor, bColor  }  
      BACKCOLOR { 209,238,238 }
      FONTCOLOR { 000,255,020 } 
      ONCHANGE ArribAbajo()  
      MULTISELECT .F.
      FONTNAME 'Arial'
      FONTSIZE 9
      CELLNAVIGATION .T.
   END GRID

      Form_1.Grid_2.CheckBoxEnabled := .T.

      @ 420,140 LABEL Label_1 ;
		WIDTH 120 HEIGHT 17 ;
		VALUE 'Total Records:' ;
		FONT 'Arial' SIZE 10  BOLD ITALIC

      @ 420,250 LABEL Label_2 ;
		WIDTH 100 HEIGHT 17 ;
		VALUE '' ;
		FONT 'Arial' SIZE 10  BOLD ITALIC

*----------------------------------- BUTTON   First  Previous  Next  Last   ------------------------------*

    DEFINE BUTTON But_01
         ROW    415  
         COL    350
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/btn_01.bmp"
         TOOLTIP 'Primero / First '
         ACTION  GoFirst()  
    END BUTTON

    DEFINE BUTTON But_02
         ROW    415 
         COL    380 
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/btn_02.bmp"
         TOOLTIP 'Anterior / Previous '
         ACTION GoPrevious()  
    END BUTTON

    DEFINE BUTTON But_03
         ROW    415 
         COL    410
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/btn_03.bmp"
         TOOLTIP 'Siguiente / Next '
         ACTION  GoNext() 
    END BUTTON

    DEFINE BUTTON But_04
         ROW    415  
         COL    440
         WIDTH  030
         HEIGHT 030
         PICTURE "Resource/btn_04.bmp"
         TOOLTIP 'Ultimo / Last '
         ACTION  GoLast() 
    END BUTTON

*-------------------------------------------------------------------*

    DEFINE BUTTON But_05
         ROW    415 
         COL    520  
         WIDTH  100
         HEIGHT 030
         CAPTION 'Exit'   
         TOOLTIP 'Exit '
         ACTION  Form_1.Release
    END BUTTON

*---------------------------------------------------------------------------------------------------------*

    END WINDOW
        
        HMG_ChangeWindowStyle ( GetControlHandle("Grid_2","Form_1"), LVS_REPORT, NIL, .T. )
        SETWINDOWCURSOR (Form_1.But_05.Handle, "resource\finger.cur")
        
	CENTER WINDOW Form_1
	ACTIVATE WINDOW Form_1

Return

***********************************************************************************************************************************************

*---------------------------------------------------------*
 Function IniTius()
*---------------------------------------------------------*

 Form_1.Grid_2.SetFocus
 Form_1.Grid_2.Value := { 1, Form_1.Grid_2.Value[2] }
 ArribAbajo()   

 Return

*---------------------------------------------------------*
 Function GoFirst()
*---------------------------------------------------------*

 Form_1.Grid_2.SetFocus
 Form_1.Grid_2.Value := { 1, Form_1.Grid_2.Value[2] }
 ArribAbajo()   

 Return

*---------------------------------------------------------*
 Function GoPrevious()
*---------------------------------------------------------*
  LOCAL aValue := Form_1.Grid_2.Value

  Form_1.Grid_2.SetFocus

  IF aValue[1] > 1
    Form_1.Grid_2.Value := { aValue[1] - 1, aValue[2] }
    ArribAbajo()   
  ENDIF

 Return

*---------------------------------------------------------*
 Function GoNext()
*---------------------------------------------------------*
  LOCAL aValue := Form_1.Grid_2.Value

  Form_1.Grid_2.SetFocus

  IF aValue[1] < Form_1.Grid_2.Itemcount
    Form_1.Grid_2.Value := { aValue[1] + 1, aValue[2] }
    ArribAbajo()   
  ENDIF

 Return

*---------------------------------------------------------*
 Function GoLast()
*---------------------------------------------------------*

 Form_1.Grid_2.SetFocus
 Form_1.Grid_2.Value := { Form_1.Grid_2.Itemcount, Form_1.Grid_2.Value[2] }

 ArribAbajo()   


 Return

*****************************************************************************************************************************************

*----------------------------*
FUNCTION ArribAbajo()      // Cuenta Registros
*----------------------------*

 Form_1.Label_2.Value :=   ALLTRIM( STR(Form_1.Grid_2.Value[ 1 ] )) + " / " + ALLTRIM( STR(Form_1.Grid_2.ItemCount )) 

Return 	

*------------------------------*
FUNCTION  CreateArray_1()  // aRows
*------------------------------*
        LOCAL nBra1

        USE STOCK EXCLUSIVE NEW
	DbGOTOP()
        COUNT TO nBra1 FOR STOCK->REF >= 0
     *  MsgInfo( nBra1 ,"Total Records" )   // <----------- Optional
        DBEVAL( {|| AADD( aRows, { STOCK->REF,STOCK->PRODUCTO,STOCK->TIPO,TRAN(STOCK->PRECIO,"@E 9,999,999.99"),STOCK->CBARRAS,STOCK->VECTOR } ) } ) 
          
Return  


***********************************************************************************************************************************************


