*------------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*------------------------------------------*

#include "hmg.ch"

FUNCTION Main

*------------------------------------------------------------------------------------------------------------------*    
 Private  fColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , BLUE , RED ) }
 Private  bcolor := { || if ( This.CellRowIndex/2 = int (This.CellRowIndex/2) , {180,200,255} , {255,255,211} ) }   
*--------------------------------------------------- Color Barra Video Inversa ------------------------------------*
  _HMG_SYSDATA [ 348 ] := { 199,250,225 }    
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }   
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }   
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }  
*-------------------------------------------------------------------------------------------------------------------*

   REQUEST DBFCDX , DBFFPT , DBFDBT
   RDDSETDEFAULT( "DBFCDX" )

   REQUEST HB_CODEPAGE_ESWIN     
   HB_SETCODEPAGE("ESWIN")    
 
   REQUEST HB_LANG_ES   
   HB_LANGSELECT("ES")  
  
 *----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET DECIMALS TO 2
  SET TOOLTIPSTYLE BALLOON
*----------------------------------*

  PRIVATE aReg , nValor ,  Regs    
 
  DEFINE WINDOW Form_1     ;
      AT 90,90             ;
      WIDTH 580            ;
      HEIGHT 330           ;
      TITLE "Grid DBF - " + STR( YEAR( DATE()) ) ;
      MAIN NOSIZE NOMAXIMIZE     
  
      ON KEY ESCAPE ACTION Form_1.Release   

      USE PRODUTO VIA "DBFCDX"
      dbgotop()
  
   DEFINE GRID Grid_1
        ROW    020
        COL    020
        WIDTH  540  
        HEIGHT 185  
        ITEMS Nil
        VALUE Nil
        WIDTHS  grid_data_widths()
        HEADERS grid_data_headers()
        FONTNAME "Arial"
        FONTSIZE 9   
        FONTBOLD .T.
        FONTITALIC .F.
        ALLOWEDIT .F.
        ONCHANGE PositionData()
        DYNAMICFORECOLOR { fColor , fColor, fColor , fColor, fColor, fColor  } 
        DYNAMICBACKCOLOR { bColor , bColor, bColor , bColor, bColor, bColor  }  
        COLUMNCONTROLS grid_data_columncontrols()
        SHOWHEADERS .T.
        CELLNAVIGATION .T.
        ROWSOURCE "produto"
        COLUMNFIELDS grid_data_columnfields()
        JUSTIFY { GRID_JTFY_RIGHT,GRID_JTFY_LEFT,GRID_JTFY_RIGHT, GRID_JTFY_CENTER,GRID_JTFY_CENTER,GRID_JTFY_CENTER }  
    END GRID

*------------------------------ N de Registro / Total -------------------------*

            @ 244, 040 Label Label_1G    ;
                     width   120           ;
                     height  035           ;
                     FONT "Arial" SIZE 9 BOLD ITALIC;
                     Value "Records:"
                   
              @ 244, 110 Label Label_2G    ;
                     width   050           ;
                     height  035           ;
                     FONT "Arial" SIZE 9 BOLD ITALIC;
                     Value ""
*--------------------------------------------------------------------------------*

     DEFINE BUTTON But_Exit
         ROW    240
         COL    430 
         WIDTH  105
         HEIGHT 030
         CAPTION "&Exit"  
         PICTURE "Resource\Cancel.bmp"
         PICTALIGNMENT LEFT              
         ACTION Form_1.Release
    END BUTTON   

*-----------------------------------------------------------------------------------*
*-----------------------------------------  Up-Down  -------------------------------*
*-----------------------------------------------------------------------------------* 
*-----------------------------------------------------------------------------------* 
  
   DEFINE BUTTON But_01  
         ROW    240    
         COL    195          
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen01.jpg"            
         TOOLTIP 'First'//'Primero'    
         ACTION ( dBGoTop() , Form_1.Grid_1.RecNo := Produto->(RecNo()) , PositionData())                            
     END BUTTON

    DEFINE BUTTON But_02 
         ROW    240  
         COL    225  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen02.jpg"     
         TOOLTIP 'Previous'//'Anterior'   
         ACTION  ( dBSkip ( -1 ) , Form_1.Grid_1.RecNo := Produto->(RecNo()) , PositionData() ) 
    END BUTTON
 
    DEFINE BUTTON But_03
         ROW    240 
         COL    255  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen03.jpg"
         TOOLTIP 'Next'//'Siguiente'    
         ACTION ( dBSkip (1) , if ( Eof() , DbGoBottom() , Nil ) , Form_1.Grid_1.RecNo := Produto->(RecNo()) , PositionData()) 
    END BUTTON   

    DEFINE BUTTON But_04
         ROW    240 
         COL    285  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen04.jpg"   
         TOOLTIP 'Last'  //'Ultimo' 
         ACTION ( dBGoBottom () , Form_1.Grid_1.RecNo := Produto->(RecNo()) , PositionData() )
    END BUTTON     
 
    Chane_Style()   

  END WINDOW

   SETWINDOWCURSOR (Form_1.But_Exit.Handle, "resource\finger.cur")

    Form_1.Grid_1.Refresh
    Form_1.Grid_1.SetFocus  

   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

Return nil

*------------------------------------------------------------* 
FUNCTION Chane_Style()   // Hace Recuadro en Grid
*------------------------------------------------------------* 
 HMG_ChangeWindowStyle ( GetControlHandle("Grid_1","Form_1"), LVS_REPORT, NIL, .T. )

Return

*------------------------------------------------------------* 
 Function PositionData()  // N de Registro / Total  
*------------------------------------------------------------*
 aReg    :=  Form_1.Grid_1.Value  
 nValor  :=  0
 Regs    :=  STR( Form_1.Grid_1.ItemCount )  
 
   Select('produto')
   nValor := aReg[1] 
   Form_1.Label_2G.value :=  ALLTRIM( STR( nValor) ) + SPACE(1) + "/" + SPACE(1) + ALLTRIM( Regs)    

Return 

*------------------------------------------------------------* 
FUNCTION grid_data_DynamicBackColor()
*------------------------------------------------------------* 

LOCAL aDynamicBackColor := {}

   aDynamicBackColor := { bBackColor,;
                          bBackColor,;
                          bBackColor,;
                          bBackColor,;
                          bBackColor,;
                          bBackColor }

RETURN aDynamicBackColor

*------------------------------------------------------------* 
FUNCTION grid_data_widths()
*------------------------------------------------------------* 

LOCAL awidths := {}

   awidths := { 70,342,100,100,60,82 }   

RETURN awidths

*------------------------------------------------------------* 
FUNCTION grid_data_headers()
*------------------------------------------------------------* 

LOCAL aheaders

   aheaders := { "Codigo",;
                 "Nome",;
                 "Preco",;
                 "Entrada",;
                 "Ativo",;
                 "Observao" }

RETURN aheaders

*------------------------------------------------------------* 
FUNCTION grid_data_columncontrols()
*------------------------------------------------------------* 

LOCAL aColumnControls

   aColumnControls := { { "TEXTBOX","NUMERIC","99999" },;
                        { "TEXTBOX","CHARACTER" },;
                        { "TEXTBOX","NUMERIC","999999999999.99" },;
                        { "DATEPICKER","UPDOWN" },;
                        { "CHECKBOX",".T.",".F."},;
                        { "EDITBOX" } }

RETURN aColumnControls 

*------------------------------------------------------------* 
FUNCTION grid_data_columnfields()
*------------------------------------------------------------* 
LOCAL aColumnFields

   aColumnFields := { "produto->codpro",;
                      "produto->nompro",;
                      "TRAN(produto->prepro, '@E 9,999,999.99')",;         // <----Euro    "produto->prepro",;
                      "produto->datpro",;
                      "produto->sitpro",;
                      "produto->obspro" }

RETURN aColumnFields 

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*