 #include <hmg.ch>
 #include <Sql1.prg>

 FUNCTION Main

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*
    
  SET CODEPAGE TO UNICODE  
  
  SET EXCLUSIVE OFF
  SET CENTURY ON 
  SET DATE FRENCH 
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET EPOCH TO 2000
  SET ESCAPE ON
  SET DELETED ON 
  SET NAVIGATION EXTENDED
  SET BROWSESYNC ON
  SET DECIMALS TO 0

*-------------------------------------*
  PuBLIC aGrid  := {}
  PuBLIC aTable := {}
*-------------------------------------*

  DEFINE WINDOW Form_1     ;
      AT 90,90             ;
      WIDTH 580            ;
      HEIGHT 330           ;
      TITLE "SQlite Grid -" + STR( YEAR( DATE()) ) ;
      MAIN NOSIZE NOMAXIMIZE       ;
      ON INIT main_button_1_action() 
      ON KEY ESCAPE ACTION Form_1.Release           
 
*------------------------------------------------------------------------------------------------------------------*
 Private  fColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , BLUE , RED ) }
 Private  bcolor := { || if ( This.CellRowIndex/2 = int (This.CellRowIndex/2) , {180,200,255} , {255,255,211} ) }   
*------------------------------------------------- Color Barra Video Inversa --------------------------------------*
  _HMG_SYSDATA [ 348 ] := { 199,250,225 }    
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }   
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }   
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }  
*-------------------------------------------------------------------------------------------------------------------*

    DEFINE GRID Grid_1
        ROW    010  
        COL    010  
        WIDTH  550        
        HEIGHT 201  //197
        ITEMS aGrid                             
        VALUE 1
        WIDTHS  { 080,258,100,110,070,0,0 }   // 0 <----  porque asi no sale en Grid  0   <--- because that's not in Grid 
        HEADERS {"Code", "Name", "Phone", "Date", "Married", "", ""}    
        FONTNAME "Arial"
        FONTSIZE 9
        FONTBOLD .T.
        FONTITALIC .F.
        ONCHANGE NumeroRegistry()
        DYNAMICFORECOLOR { fcolor, fcolor, fcolor, fcolor, fcolor, fcolor, fcolor} 
        DYNAMICBACKCOLOR { bColor ,bColor ,bColor ,bColor ,bColor ,bColor ,bColor }  
        SHOWHEADERS .T.
        CELLNAVIGATION .F. 
        JUSTIFY { BROWSE_JTFY_RIGHT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT  , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT, BROWSE_JTFY_LEFT  }     
     END GRID

*-----------------------------------------------------------------------------------*
*-------------------------------------- Exit ---------------------------------------*
*-----------------------------------------------------------------------------------*

     DEFINE BUTTON But_Exit
         ROW    240
         COL    430 
         WIDTH  105
         HEIGHT 030 
         CAPTION "&Exit"  
         PICTURE "Resource\Cancel.bmp"
         PICTALIGNMENT LEFT             
         ACTION Form_1.Release
    END BUTTON   

*-----------------------------------------------------------------------------------*

              @ 245, 050 Label Label_1G    ;
                     width   120           ;
                     height  035           ;
                     FONT "Arial" SIZE 9 BOLD ITALIC;
                     Value "Records:"
                   
              @ 245, 120 Label Label_2G    ;
                     width   050           ;
                     height  035           ;
                     FONT "Arial" SIZE 9 BOLD ITALIC;
                     Value ""

*-----------------------------------------------------------------------------------*
*-----------------------------------  Up-Down  -------------------------------------*
*-----------------------------------------------------------------------------------* 
*-----------------------------------------------------------------------------------* 

   DEFINE BUTTON But_01  
         ROW    240    
         COL    195          
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen01.jpg"            
         TOOLTIP 'First'//'Primero'    
         ACTION GoFirst()                            
     END BUTTON

    DEFINE BUTTON But_02 
         ROW    240  
         COL    225  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen02.jpg"     
         TOOLTIP 'Previous'//'Anterior'   
         ACTION GoPrevious()
    END BUTTON
 
    DEFINE BUTTON But_03
         ROW    240 
         COL    255  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen03.jpg"
         TOOLTIP 'Next'//'Siguiente'    
         ACTION GoNext()         
    END BUTTON   

    DEFINE BUTTON But_04
         ROW    240 
         COL    285  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen04.jpg"   
         TOOLTIP 'Last'  //'Ultimo' 
         ACTION  GoLast()
    END BUTTON   
  
   Chane_Style()    

  END WINDOW

  SETWINDOWCURSOR (Form_1.But_Exit.Handle, "resource\finger.cur")
 
  Form_1.Center
  Form_1.Activate

Return Nil

*----------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------*

*------------------------------------------------------------* 
FUNCTION Chane_Style()   // Hace Recuadro en Grid
*------------------------------------------------------------* 
 HMG_ChangeWindowStyle ( GetControlHandle("Grid_1","Form_1"), LVS_REPORT, NIL, .T. )

Return

*---------------------------------------------------------*
 Function GoFirst()
*---------------------------------------------------------*

   Form_1.Grid_1.value := 1

 return

*---------------------------------------------------------*
 Function GoPrevious()
*---------------------------------------------------------*

   if Form_1.Grid_1.value > 1
      Form_1.Grid_1.value := Form_1.Grid_1.value - 1
   endif
 return

*---------------------------------------------------------*
 Function GoNext
*---------------------------------------------------------*

   if Form_1.Grid_1.value < Form_1.Grid_1.itemcount
      Form_1.Grid_1.value := Form_1.Grid_1.value + 1
   endif

 return
*---------------------------------------------------------*
 Function GoLast()
*---------------------------------------------------------*

   Form_1.Grid_1.value := Form_1.Grid_1.itemcount

 return


*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*


*-------------------------------------------------------*
Function  NumeroRegistry()   // N de Registro / Total  
*-------------------------------------------------------*
PRIVATE aline :={}
PRIVATE aReturnX_Sql
PRIVATE aDataRecordX
PRIVATE nToRecords
PRIVATE ncQuery_
PRIVATE numerRt 

 nToRecords := 0

 ncQuery_ := "SELECT id, nombre, telefono, fecha , Married , notas , PHOTO FROM personales ORDER BY  id"

 aReturnX_Sql := Sqlite_Cmd( dbo, ncQuery_  )

  FOR EACH aDataRecordX IN aReturnX_Sql
      ID := aDataRecordX[ 1 ]
            nToRecords ++
  NEXT  aDataRecordX

  numeRt :=  nToRecords ++
  
  If Form_1.Grid_1.value > 0

     aline := Form_1.Grid_1.item(Form_1.Grid_1.value)
 
     Form_1.Label_2G.value    :=  aline[1] +space(1)+"/"+space(1)+ ALLTRIM(STR(( numeRt )))

  endif
 
 Return 


*-------------------------------------------*
Function main_button_1_action()
*-------------------------------------------*

 public dbo := nil

 If .not. file("nombre.sqlite")
     crearbase("nombre.sqlite")
     msginfo("Base Created")   //<----------- ("BASE Creada") 
     return nil
  Else
   dbo := connect2db("nombre.sqlite",.f.)
    If dbo == nil
       msginfo("can not connect to the Base")    //<------ ("no se puede conectar con la Base")
      return nil
    Endif
 Endif   

 datossqlite()

*-------------------------------------------*
Function crearbase(mDb)
*-------------------------------------------*

*----------------------------------------------------------------------------------------------------*

 * miscsql always require two parameters. First one is dbo object and the next one is the query. 
 * When creating a database, we have to use connect2db with .T. as the second parameter. 
 * I hope this helps.
 * Rathinagiri

 * miscsql siempre requiere dos parmetros. El primero es objeto dbo y la siguiente es la consulta. 
 * Al crear una base de datos, tenemos que usar con connect2db .T. como el segundo parmetro.
 * Espero que esto ayude.
 * Rathinagiri 

*----------------------------------------------------------------------------------------------------*

  local sQry
  local lOk := .f.

  sQry := "CREATE TABLE IF NOT EXISTS personales (id INTEGER PRIMARY KEY, nombre VARCHAR(55),telefono VARCHAR(15), fecha VARCHAR(10), Married VARCHAR(6), notas VARCHAR(80),PHOTO VARCHAR(15) );"  

  dbo := connect2db(mDb, .t.)
  lOk := miscsql(dbo,sQry)

return nil  

*-------------------------------------------*
Function datossqlite()
*-------------------------------------------*

   local aTable := {}
   private lModify := .f.

   if dbo == nil
     return nil
   endif

   Form_1.Grid_1.deleteallitems()

        aTable := sql(dbo,"SELECT id, nombre, telefono, fecha , Married , notas , PHOTO FROM personales ORDER BY  id")

   if len(aTable) > 0

     for i := 1 to len(aTable)
       Form_1.Grid_1.additem({str(aTable[i,1]),UPPER(aTable[i,2]),aTable[i,3], aTable[i,4],aTable[i,5],aTable[i,6],aTable[i,7]})
    next i 
 
    Form_1.Grid_1.value := 1

   endif   

  Return Nil

*------------------------------------------------------------------------------------------------------------------------------*
*------------------------------------------------------------------------------------------------------------------------------*

















